   ' ************************************
10 ' *** (FFT12.01) VOICE SPEEDUP FFT ***
   ' ************************************
' DYNAMIC
12 CLS : SK1 = 1: SK3 = 1: Q = 2 ^ 11: Q2 = Q / 2
14 PATHI$ = "C:\": PATHO$ = PATHI$
16 DIM C(Q), S(Q), KC(Q2), KS(Q2), HDR(44)
18 FOR I = 1 TO 44: READ HDR(I): NEXT I
20 DATA 82,73,70,70,187,23,0,0,87,65,86,69,102,109,116,32,16,0,0,0,1
22 DATA 0,1,0,17,43,0,0,17,43,0,0,1,0,8,0,100,97,116,97,151,23,0,0
24 PI = 3.141592653589793#: P2 = 2 * PI: K1 = P2 / Q
30 Q3 = Q2 - 1
32 FOR I = 0 TO Q3: KC(I) = COS(I * K1): KS(I) = SIN(I * K1): NEXT I
34 INPUT "INPUT DATA SAMPLE RATE"; DSR1
36 CLS : GOSUB 1100 ' GET DATA FILE
40 CLS
50 PRINT SPC(30); "MAIN MENU": PRINT : PRINT
52 PRINT SPC(5); "1 = FFT": PRINT
54 PRINT SPC(5); "2 = INV FFT": PRINT
56 PRINT SPC(5); "3 = DISPLAY MENU": PRINT
58 PRINT SPC(5); "4 = SPEEDUP ROUTINE": PRINT
60 PRINT SPC(5); "5 = FILE UTILITY": PRINT
62 PRINT SPC(5); "6 = FILTER": PRINT
68 PRINT SPC(5); "9 = EXIT": PRINT
70 PRINT SPC(10); "MAKE SELECTION :";
80 A$ = INKEY$: IF A$ = "" THEN 80
82 IF ASC(A$) < 49 OR ASC(A$) > 57 THEN 40
90 A = VAL(A$): ON A GOSUB 600, 700, 800, 400, 1000, 3000, 990, 990, 990
95 IF A = 9 THEN 999
97 GOTO 40

 '  *******************************************************
 '  *               FORWARD PFFFT                         *
 '  *******************************************************
100 '          ***  TRANSFORM STAGE 1  ***
108 T9 = TIMER
110 C(0) = (S(0) + S(Q2)) / 2: C(1) = (S(0) - S(Q2)) / 2
112 FOR I = 1 TO Q3: I2 = 2 * I: INDX = 0
114 FOR J = 0 TO N1: IF I AND 2 ^ J THEN INDX = INDX + 2 ^ (N - 2 - J)
116 NEXT J
118 C(I2) = (S(INDX) + S(INDX + Q2)) / 2: C(I2 + 1) = (S(INDX) - S(INDX + Q2)) / 2
120 NEXT I
122 FOR I = 0 TO Q1: S(I) = 0: NEXT I
'       *********  REMAINING STAGES  **********
124 FOR M = 1 TO N1: QP = 2 ^ M: QPI = 2 ^ (N1 - M)
126  FOR K = 0 TO QPI - 1
128   FOR J = 0 TO QP / 2: J0 = J + (2 * K * QP): J1 = J0 + QP: K2 = QPI * J * K1
130   JI = J1 - (2 * J)
132   CTEMP1 = C(J0) + C(J1) * COS(K2) - S(J1) * SIN(K2)
134   STEMP1 = S(J0) + C(J1) * SIN(K2) + S(J1) * COS(K2)
136   CTEMP2 = C(J0) - C(J1) * COS(K2) + S(J1) * SIN(K2)
138   S(JI) = (C(J1) * SIN(K2) + S(J1) * COS(K2) - S(J0)) / 2
140   C(J0) = CTEMP1 / 2: S(J0) = STEMP1 / 2: C(JI) = CTEMP2 / 2
142   NEXT J
144  NEXT K
146 NEXT M
148 FOR J = Q2 + 1 TO Q1: C(J) = 0: S(J) = 0: NEXT J
150 T9 = TIMER - T9: SK1 = 2
152 RETURN

 '  ****************************************************
 '  *              INVERSE TRANSFORM                   *
 '  ****************************************************
200 PRINT : T9 = TIMER: SK1 = 1: QP = 2 ^ N1
202 FOR M = N1 TO 1 STEP -1' LOOP FOR STAGES OF COMPUTATION
204  QP2 = 2 ^ (M): QP = INT(QP / 2): QP4 = 2 * QP2: QPI = 2 ^ (N1 - M)
206  FOR I = 0 TO Q - (QP2) STEP QP4
208   FOR J = 0 TO QP: KI = J + I: KT = J * QPI * K1: KJ = QP2 + KI
212    MCT = C(J + I) - C(I + QP2 - J): MST = S(J + I) + S(I + QP2 - J)
214    CTEMP = MCT * COS(KT) + MST * SIN(KT)
216    STEMP = MST * COS(KT) - MCT * SIN(KT)
218    CTEMP2 = (2 * C(J + I)) - CTEMP * COS(KT) + STEMP * SIN(KT)
220    S(KI) = (2 * S(J + I)) - CTEMP * SIN(KT) - STEMP * COS(KT)
222    C(KJ) = CTEMP: S(KJ) = STEMP: C(KI) = CTEMP2
224   NEXT J
226  NEXT I
228 NEXT M
229 '    ********  FINAL STAGE  ********
230 FOR I = 0 TO Q3: I2 = 2 * I: INDX = 0
232 FOR J = 0 TO N1: IF I AND 2 ^ J THEN INDX = INDX + 2 ^ (N - 2 - J)
234 NEXT J
236 S(INDX) = C(I2) + C(I2 + 1): S(INDX + Q2) = C(I2) - C(I2 + 1)
238 NEXT I
240 FOR I = 0 TO Q1: C(I) = 0: NEXT I
242 T9 = TIMER - T9
244 RETURN



 '  ******************************
 '  *        VOICE SPEEDUP        *
 '  ******************************
400 CLS : PRINT : PRINT
402 PRINT SPC(20); "VOICE SPEEDUP MENU": PRINT : PRINT
404 PRINT SPC(5); "1 = STRETCH SIDEBANDS     2 = FRACTIONAL STRETCH"
405 PRINT SPC(5); "9 = EXIT"
406 A$ = INKEY$: IF A$ = "" THEN 406
407 ON VAL(A$) GOSUB 450, 412, 410, 410, 410, 410, 410, 410, 410
410 RETURN
412 ' ***  FRACTIONAL STRETCH  ***
414 CLS : INPUT "SELECT CENTER FREQUENCY"; FCO1
415 FCO1 = FCO1 * Q / DSR1
416 PRINT SPC(20); "SELECT SPEEDUP FRACTION": PRINT : PRINT
417 PRINT SPC(5); "1 = -3/4         5 = +1/4"
418 PRINT SPC(5); "2 = -1/2         6 = +1/2"
419 PRINT SPC(5); "3 = -1/4         7 = +3/4"
420 PRINT SPC(5); "4 = 0            8 = N/A"
421 PRINT SPC(5); "9 = EXIT"
422 A$ = INKEY$: IF A$ = "" THEN 422
423 IF ASC(A$) < 49 OR ASC(A$) > 57 THEN 414
424 A = VAL(A$): IF A = 9 GOTO 449
425 A = A - 4: IF A > 3 THEN A = 3
426 FCO1 = CINT(FCO1): DELF = 4 - A
' SELECT SIDEBANDS
427 I2 = -1: FCO4 = CINT(FCO1 / 8): IX = INT(FCO1 * DELF / 8)
428 FOR I = 0 TO IX STEP DELF: I2 = I2 + 1
429 C(FCO4 + I2) = C(FCO1 + I): S(FCO4 + I2) = S(FCO1 + I)
430 C(FCO4 - I2) = C(FCO1 - I): S(FCO4 - I2) = S(FCO1 - I)
431 NEXT I
432 FOR I = FCO4 + I2 TO Q - 1: C(I) = 0: S(I) = 0: NEXT I
433 N = N - 3: N1 = N - 1: Q = 2 ^ N: K1 = P2 / Q
434 Q2 = Q / 2: Q3 = Q2 - 1: Q4 = Q / 4: Q5 = Q4 - 1: Q8 = Q / 8
436 FOR I = 0 TO Q2: KC(I) = COS(K1 * I): KS(I) = SIN(K1 * I): NEXT I
449 RETURN
450 ' ******  STRETCH SIDEBANDS  *****
452 INPUT "CARRIER FREQUENCY IS"; FCO1
454 FCO1 = FCO1 * Q / DSR1
456 FOR I = 100 TO 0 STEP -1: I2 = 2 * I: I3 = I2 - 1
460 C(FCO1 + I2) = C(FCO1 + I): S(FCO1 + I2) = S(FCO1 + I)
462 C(FCO1 + I3) = 0: S(FCO1 + I3) = 0
464 C(FCO1 - I2) = C(FCO1 - I): S(FCO1 - I2) = S(FCO1 - I)
466 C(FCO1 - I3) = 0: S(FCO1 - I3) = 0
468 NEXT I
470 RETURN
600 ' **************************************
   '  *            FORWARD FFT             *
   '  **************************************
602 CLS : SK1 = 1: K6 = 1: KFB = 2
604 LOCATE 12, 20: PRINT "PLEASE WAIT - TRANSFORMING DATA"
620 GOSUB 100' DO PFFFT
622 CLS : GOSUB 2500' PLOT DATA
624 RETURN
'    **********************************
700 '***         INVERSE FFT        ***
'    **********************************
710 K6 = -1: KFB = 1
712 CLS : LOCATE 12, 20: PRINT "PLEASE WAIT - XFORMING DATA."
714 GOSUB 200' DO INVERSE PFFFT
716 CLS : GOSUB 2000' PLOT DATA
718 RETURN
 '      *************************
800  '  *** DISPLAY DATA MENU ***
 '      *************************
802 CLS : PRINT SPC(30); "DISPLAY MENU ": PRINT : PRINT
804 PRINT SPC(5); "1 = DISPLAY TIME DOMAIN (GRAPHIC)"
806 PRINT SPC(5); "2 = DISPLAY FREQ DOMAIN (GRAPHIC)"
808 PRINT SPC(5); "9 = EXIT"
810 A$ = INKEY$: IF A$ = "" THEN 810
812 IF ASC(A$) < 49 OR ASC(A$) > 57 THEN 802
814 ON VAL(A$) GOSUB 2000, 2500, 816, 816, 816, 816, 816, 816, 816
816 RETURN
990 CLOSE : RETURN
999 END
 '       ************************
 '       *       FILE MENU      *
 '       ************************
1000 CLS : PRINT SPC(30); "FILE HANDLER MENU ": PRINT : PRINT
1002 PRINT SPC(5); "1 = RELOAD FILE           2 = SAVE FILE"
1004 PRINT SPC(5); "3 = LOAD NEW FILE         4 = CHANGE SAMPLE RATE"
1006 PRINT SPC(5); "5 = WEIGHTING FUNCTION"
1010 PRINT SPC(5); "9 = EXIT"
1012 A$ = INKEY$: IF A$ = "" THEN 1012
1014 ON VAL(A$) GOSUB 1110, 1200, 1100, 1040, 1060, 1018, 1018, 1018, 1018
1018 RETURN
'   ********   CHANGE INPUT PATH ***********
1020 NPATH$ = ""
1022 INPUT "NEW PATH"; NPATH$
1024 IF NPATH$ = "" THEN 1024
1026 PATHI$ = NPATH$
1028 RETURN
'*********  CHANGE OUTPUT PATH   ************
1030 NPATH$ = ""
1032 INPUT "NEW PATH"; NPATH$
1034 IF NPATH$ = "" THEN 1034
1036 PATHO$ = NPATH$
1038 RETURN
'  ************  CHANGE SAMPLE RATE  ************
1040 NRATE = 0
1042 INPUT "NEW SAMPLE RATE"; NRATE
1044 IF NRATE = 0 OR NRATE > 44100 THEN 1042
1046 DSR1 = NRATE: TO0 = Q / DSR1
1048 RETURN
 ' ********  WEIGHTING FUNCTION  **********
1050 FOR I = 0 TO Q1
1052 S(I) = S(I) * (SIN(I * PI / Q) ^ 6)
1054 NEXT I
1056 RETURN
 ' *********  WEIGHTING ON/OFF  ************
1060 PRINT "WEIGHTING ON (Y/N)?";
1062 A$ = INKEY$: IF A$ = "" THEN 1062
1064 IF A$ = "Y" OR A$ = "y" THEN WTFLG = 1
1066 IF A$ = "N" OR A$ = "n" THEN WTFLG = 0
1068 IF A$ <> "Y" AND A$ <> "y" AND A$ <> "N" AND A$ <> "n" THEN 1060
1070 RETURN
'   *******************
'   ***  LOAD FILE  ***
'   *******************
1100 CLS : NUFLG = 1
1102 PRINT "FILENAME ('PATH' TO CHANGE PATH)"; PATHI$;
1104 INPUT NMI$
1106 IF NMI$ = "PATH" THEN GOSUB 1020: GOTO 1100
1108 NMI$ = PATHI$ + NMI$
1109 IF RIGHT$(NMI$, 4) <> ".WAV" THEN NMI$ = NMI$ + ".WAV"
1110 OPEN "R", #1, NMI$, 1
1112 FIELD #1, 1 AS DA$
1114 QDF = LOF(1): QF = QDF - 44
1116 GET #1, 23                 'GET NUMBER OF CHANNELS
1118 CHNLS = ASC(DA$): IF CHNLS = 2 THEN QF = QF / 2'(MONO?STEREO?
1120 GET #1, 35
1122 WRDSIZ = ASC(DA$): IF WRDSIZ = 16 THEN QF = QF / 2' TWO BYTES
1126 PRINT QF; " AFTER WORDSIZE & # CHANNELS"
1128 GET #1, 26 ' GET SAMPLE RATE HIGH BYTE
1129 SR1 = ASC(DA$)
1130 SR1 = 256 * SR1 ' FILE S/R
1132 GET #1, 25
1134 SR1 = SR1 + ASC(DA$): DSR1 = SR1
1136 CLOSE 1
1138 STZ = 1
1142 IF NUFLG = 0 THEN 1152
1144 NUFLG = 0
1145 PRINT "FREE MEMORY ="; FRE(-1)
1146 PRINT "8 * QF = "; 8 * QF; " PROCEED?";
1148 A$ = INKEY$: IF A$ = "" THEN 1148
1150 IF A$ = "N" OR A$ = "n" THEN 1194
1152 FOR N = 10 TO 13' FIND SIZE OF REQUIRED ARRAY
1154 IF QF <= 2 ^ N THEN 1158
1156 NEXT N
1157 REPROF = 0: 'QF = 2 ^ (N)
1158 IF A$ = "Q" OR A$ = "q" THEN N = 14
1160 Q = 2 ^ N: N1 = N - 1: Q1 = Q - 1: Q2 = Q / 2: Q3 = Q2 - 1: Q4 = Q / 4
1161 Q5 = Q4 - 1: Q8 = Q / 8: Q9 = Q8 - 1: Q34 = Q2 + Q4: Q16 = Q / 16
1162 REDIM C(Q), S(Q)
1164 TO0 = Q / DSR1: K1 = P2 / Q
1166 CLOSE 1
      TYPE Dat3
          Amp3 AS INTEGER
      END TYPE
1176 DIM WRD AS Dat3
1180 IF WRDSIZ = 16 THEN GOSUB 1300 ELSE GOSUB 1350
1182 CLOSE #1
1184 FOR I = 0 TO Q
1186 C(I) = 0
1188 NEXT I
1190 IF WTFLG = 1 THEN GOSUB 1050
1194 CLS : GOSUB 2000
1196 RETURN
'  *******************************************
'  *        SAVE TIME DOMAIN FILE            *
'  *******************************************
1200 PRINT " SET GAIN (Y/N)?"
1202 A$ = INKEY$: IF A$ = "" THEN 1202
1204 IF A$ = "Y" OR A$ = "y" THEN GOSUB 1270
1210 HDR(7) = INT((2 * Q + 36) / 65536)
1212 HDR(6) = INT(((2 * Q + 36) - HDR(7) * 65536) / 256)
1214 HDR(5) = INT((2 * Q + 36) - (HDR(7) * 65536) - (HDR(6) * 256))
1216 HDR(43) = INT((2 * Q) / 65536)
1218 HDR(42) = INT(((2 * Q) - (HDR(43) * 65536)) / 256)
1220 HDR(41) = INT((2 * Q) - (HDR(43) * 65536) - (HDR(42) * 256))
1222 HDR(26) = INT(DSR1 / 256)
1224 HDR(25) = INT(DSR1 - (HDR(26) * 256)): DSR2 = 2 * DSR1
1226 HDR(31) = INT(DSR2 / 65536): DSR2 = DSR2 - HDR(31) * 65536
1228 HDR(30) = INT(DSR2 / 256): DSR2 = DSR2 - HDR(30) * 256
1230 HDR(29) = INT(DSR2)
1232 PRINT : PRINT "FILENAME ('PATH' TO CHANGE PATH) "; PATHO$;
1234 INPUT NM2$
1236 IF NM2$ = "PATH" THEN GOSUB 1030: GOTO 1232
1238 NM$ = PATHO$ + NM2$
1240 OPEN "R", #2, NM$, 2
1242 FIELD #2, 2 AS DA2$
1244 FOR I = 1 TO 43 STEP 2
1246 HDR1 = HDR(I) + HDR(I + 1) * 256
1248 IF HDR1 < 32768 THEN LSET DA2$ = MKI$(HDR1): GOTO 1252
1250 LSET DA2$ = CHR$(HDR(I)) + CHR$(HDR(I + 1))
1252 PUT #2, (I + 1) / 2
1254 NEXT I
1256 FOR I = 0 TO Q - 1
1258 LSET DA2$ = MKI$(INT(SK3 * S(I)))
1260 PUT #2, (I + 23)
1262 NEXT I
1264 CLOSE #2
1266 RETURN
1270 ' ************ SET GAIN *************
1272 ITST = 0: NGAIN = 0
1274 FOR I = 0 TO Q - 1
1276 IF ABS(S(I)) > ITST THEN ITST = ABS(S(I))
1278 NEXT I
1280 PRINT : PRINT "THE PEAK VALUE IN THE ARRAY IS "; ITST
1282 PRINT "MAXIUM GAIN = "; (4096 / ITST)
1284 INPUT "NEW GAIN = "; NGAIN
1286 IF NGAIN = 0 THEN 1282
1288 SK3 = NGAIN
1290 PRINT "GAIN = "; SK3
1292 INPUT "C/R TO CONTINUE"; A$
1294 RETURN
1300 '*********   LOAD 16 BIT WORDS  ************
1302 OPEN NMI$ FOR RANDOM AS #1 LEN = LEN(WRD)
1303     STZ = CHNLS ': ISTOP = 22'     'STEPSIZE = 2 FOR STERE0
1304     FOR I = 0 TO QF - 1
1305     GET #1, (STZ * I) + 45, WRD    'LOCATE STZ*I +45--SO WE STEP
1306     S(I) = WRD.Amp3                'OVER 2 WORDS FOR STEREO
1307     IF CHNLS = 1 THEN 1310         ' = MONAURAL
1308     GET #1, (STZ * I) + 46, WRD    '+46 FOR STEREO
1309     IF I > Q THEN 1312 ELSE S(I) = S(I) + WRD.Amp3
1310     NEXT I
1312 RETURN
1350 '*********   LOAD 8 BIT BYTES
1352 OPEN "R", #1, NMI$, 1
1354 FIELD #1, 1 AS DA$
1356     FOR I = 0 TO QF - 1 ' STEP STZ
1358     GET #1, (STZ * I) + 45
1360     S(I) = ASC(DA$) - 127
1362     NEXT I
1364 RETURN
 '  ***************************************
 '  *          PLOT DATA (TIME)
 '  ***************************************
2000 IF REPOF = 1 THEN RETURN
2001 SCREEN 9, 1, 1: COLOR 7, 1: MAGX = 1: X0 = 10
2002 CLS : SKX1 = 600 * MAGX / Q: SKY1 = 0
2004 FOR I = 0 TO Q - 1
2006 IF ABS(S(I)) > SKY1 THEN SKY1 = ABS(S(I))
2008 NEXT I
2010 SKY1 = 145 / SKY1: Y0 = 170
2012 Y2 = Y0 + 5: Y3 = Y0 - 5
2014 LINE (X0, Y0)-(X0, Y0): COLOR 7, 1
2016 FOR I = 0 TO Q - 1
2018 X5 = X0 + (I * SKX1): Y5 = Y0 - (S(I) * SKY1)
2020 LINE -(X5, Y5)
2022 NEXT I
2024 COLOR 15, 1
2026 LINE (10, Y0 - 150)-(10, 150 + Y0)
2028 LINE (10, Y0)-(610, Y0)
2030 FOR I = 1 TO 10
2032 X2 = 10 + 60 * I
2034 LINE (X2, Y2)-(X2, Y3)
2036 NEXT I
2038 LOCATE 1, 1: PRINT "XFORM TIME = "; INT(100 * T9) / 100; " SEC."
2040 LOCATE 1, 35: PRINT "FILE = "; NMI$
2042 LOCATE 22, 60: PRINT "Tmax ="; TO0 / MAGX;
2044 LOCATE 22, 1: PRINT "M = EXPAND: O = OFFSET";
2048 A$ = INKEY$: IF A$ = "" THEN 2048
2050 IF A$ = "M" OR A$ = "m" THEN 2056
2052 IF A$ = "O" OR A$ = "o" THEN 2070
2054 IF ASC(A$) = 27 THEN RETURN ELSE 2002
' EXPAND DATA DISPLAY
2056 IF A$ = "M" THEN MAGX = 2 * MAGX
2058 IF A$ = "m" THEN MAGX = MAGX / 2: IF MAGX < 1 THEN MAGX = 1
2060 GOTO 2002
' OFFSET DATA
2070 IF A$ = "O" AND X0 > (600 * (1 - MAGX) + 10) THEN X0 = X0 - 60
2072 IF A$ = "o" THEN X0 = X0 + 60: IF X0 > 10 THEN X0 = 10
2074 GOTO 2002
 ' ***************************************
 ' *        PLOT DATA (FREQUENCY)        *
 ' ***************************************
2500 IF REPOF = 1 THEN RETURN
2502 CLS : SCREEN 9, 1, 1: COLOR 7, 1
2504 MAGX = 1: OFS = 0: SKY1 = 0
' FIND MAX VALUE IN DISPLAY DATA & SET EQUAL TO SKY1
2506 FOR I = 0 TO Q2: YTST = SQR(C(I) ^ 2 + S(I) ^ 2)
2508 IF YTST > SKY1 THEN SKY1 = YTST
2510 NEXT I
 ' SET DISPLAY SCALE FACTOR = 200 PIXLS/SKY1
2512 SKY1 = 200 / SKY1
2514 Y0 = 300: SKY2 = SKY1 / 2
2516 SKX1 = MAGX * 600 / Q2: X0 = 10' SET X SCALE FACTOR & OFFSET
2522 GOSUB 2900 ' DRAW DATA
' IT TAKES A LOT OF WORK TO MAKE THE CURSOR PERFORM RIGHT
2530 FC = INT(Q5 / MAGX + OFS): Y3 = Y0 + 10: Y2 = Y0 - 220 ' CURSOR STUFF
2532 FCD = FC - OFS: X5 = X0 + FCD * SKX1 ' MORE CURSOR STUFF
2534 LINE (X5, Y3)-(X5, Y2) ' DRAW CURSOR
2536 GOSUB 2840 ' DISPLAY PERTINENT DIGITAL DATA
2540 A$ = INKEY$: IF A$ = "" THEN 2540' WAIT FOR USER INPUT
2542 IF A$ = CHR$(27) THEN 2552' ESC = EXIT
2544 IF ASC(A$) = 0 THEN 2590 ' HANDLE CURSOR KEYS
2546 IF A$ = "M" OR A$ = "m" THEN 2700 ' EXPAND FREQUENCY SCALE?
2548 IF A$ = "O" OR A$ = "o" THEN 2750 ' OFFSET FREQUENCY BAND
2550 GOTO 2540 ' SOMEBODY HIT THE WRONG KEY
2552 MAGX = 1: OFSI = 0: RETURN
2590 A = INT((ASC(RIGHT$(A$, 1)) - 70) / 2)' HANDLE CURSORS
2591 IF A < 1 OR A > 5 THEN 2540
2592 GOSUB 2800 ' ERASE PRESENT CURSOR
2594 ON A GOTO 2630, 2600, 2620, 2620, 2640
2596 GOTO 2540
' MOVE CURSOR DOWN ONE
2600 FC = FC - 1: IF FC < 3 THEN FC = 3
2610 FCD = FC - OFS
2612 GOSUB 2840 ' PRINT DATA
2614 LINE (X0 + SKX1 * FCD, Y3)-(X0 + SKX1 * FCD, Y2)' DRAW CURSOR
2618 GOTO 2540
' MOVE CURSOR UP ONE
2620 FC = FC + 1: IF FC > Q2 - 3 THEN FC = Q2 - 3
2626 GOTO 2610 ' NO SENSE DOING THIS TWICE
' MOVE CURSOR UP 10
2630 FC = FC + 10: IF FC > Q2 - 3 THEN FC = Q2 - 3' INCREASE CURSOR FREQUENCY BY 10
2636 GOTO 2610 ' NOR THREE TIMES
' MOVE CURSOR DOWN 10
2640 FC = FC - 10: IF FC < 3 THEN FC = 3
2644 GOTO 2610 ' DITTO
' ***   EXPAND FREQUENCY SCALE FACTOR BY 2X  ***
2700 IF A$ = "M" AND MAGX < 16 THEN MAGX = 2 * MAGX: OFSI = 2 * OFSI
2702 IF A$ = "m" AND MAGX > 1 THEN MAGX = MAGX / 2: OFSI = INT(OFSI / 2)
2704 GOTO 2756 ' NO SENSE DOING THIS TWICE EITHER
' ***   OFFSET DISPLAYED SPECTRUM
2750 IF A$ = "O" AND OFSI < MAGX THEN OFSI = OFSI + 1
2754 IF A$ = "o" AND OFSI > 0 THEN OFSI = OFSI - 1
2756 OFS = OFSI * Q2 / MAGX: CLS
2758 GOTO 2514 ' OKAY, REPLOT DATA
' ERASE CURSOR
2800 COLOR 1, 1 ' EVERYTHING BLUE
2802 FOR I = -1 TO 1 ' WHERE IS THAT THING
2804 X5 = X0 + SKX1 * (FCD + I)
2806 LINE (X5, Y3)-(X5, Y2) ' ERASE OLD CURSOR
2808 NEXT I
2810 LINE (X0, Y0)-(X0, Y0)
2812 COLOR 7, 1 ' CHANGE THE COLOR BACK
2814 GOSUB 2900 ' REDRAW DATA
2816 RETURN
' DISPLAY DATA PARAMETERS
2840 COLOR 15, 1
2842 LOCATE 24, 1: PRINT "USE ARROWS TO MOVE CURSOR/ESC TO EXIT";
2844 LOCATE 2, 1: PRINT "XFORM TIME = "; INT(100 * T9) / 100
2846 LOCATE 1, 60: PRINT "Fc ="; FC / TO0
2848 LOCATE 2, 60: YDIS = (SKY1 * SQR(C(FC) ^ 2 + S(FC) ^ 2))
2850 PRINT "MAGNITUDE = "; : PRINT USING "###.###"; YDIS / 2
2852 LOCATE 1, 1: PRINT "FILE = "; NMI$
2854 COLOR 7, 1
2856 RETURN

' DRAW DATA
2900 LINE (X0, Y0)-(X0, Y0)
2901 FOR I = OFS TO (Q2 / MAGX + OFS)
2902 X5 = (I - OFS) * SKX1: Y5 = SKY1 * SQR(C(I) ^ 2 + S(I) ^ 2)
2904 LINE -(X0 + X5, Y0 - Y5)
2906 NEXT I

' DRAW ORDINATE & ABSCISSA
2910 LINE (X0, Y0 - 200)-(X0, Y0)
2912 LINE (X0, Y0)-(600 + X0, Y0)
2920 RETURN

 '  *************************************
 '  *         FILTER ROUTINES           *
 '  *************************************
3000 CLS
3002 PRINT "LOWPASS, BANDPASS OR NOTCH (L/B/N)"
3010 A$ = INKEY$: IF A$ = "" THEN 3010
3012 IF A$ = "N" OR A$ = "n" THEN 3100 ' NOTCH FILTER
3014 IF A$ = "B" OR A$ = "b" THEN 3150 ' BANDPASS
3016 IF A$ <> "L" AND A$ <> "l" THEN 3000 ' IF NOT LOWPASS TRY AGAIN
3018 PRINT "GAUSSIAN OR TRUNCATE (G/T)" ' WHAT KIND OF LOWPASS?
3020 A$ = INKEY$: IF A$ = "" THEN 3020 ' GET USER INPUT
3022 IF A$ = "T" OR A$ = "t" THEN 3200 ' TRUNCATE?
3024 PRINT : PRINT "GAUSSIAN LOW PASS FILTER ROUTINE"
3026 INPUT "INPUT CUTOFF FREQUENCY"; FCO3
3028 FCO3 = FCO3 * TO0: FCO32 = FCO3 * FCO3
3030 FOR I = 0 TO Q / 2 ' FILTER THE DATA
3032 KAT = EXP(-.3453878 * I * I / FCO32) ' EIGEN VALUE COEFFICIENT
3034 C(I) = KAT * C(I): S(I) = KAT * S(I)
3036 C(Q - I) = KAT * C(Q - I): S(Q - I) = KAT * S(Q - I)
3038 NEXT I
3040 RETURN

3100 PRINT : PRINT "NOTCH FILTER ROUTINE"
3102 INPUT "CENTER FREQUENCY & BANDWIDTH"; FCEN, BW4
3104 FCEN = FCEN * TO0: BW4 = BW4 * TO0
3106 FOR I = FCEN - BW4 TO FCEN + BW4
3108 C(I) = 0: S(I) = 0
3110 NEXT I
3112 RETURN

3150 PRINT : PRINT "BANDPASS FILTER ROUTINE"
3152 INPUT "CENTER FREQUENCY & BANDWIDTH"; FCEN, BW4
3154 FCEN = FCEN * TO0: BW4 = BW4 * TO0
3156 FOR I = 0 TO FCEN - BW4
3158 C(I) = 0: S(I) = 0
3160 C(Q - I) = 0: S(Q - I) = 0
3162 NEXT I
3164 FOR I = FCEN + BW4 TO Q2
3166 C(I) = 0: S(I) = 0
3168 C(Q - I) = 0: S(Q - I) = 0
3170 NEXT I
3172 RETURN

3200 ' *** TRUNCATE UPPER SPECTRUM ***
3202 PRINT : PRINT "TRUNCATE UPPER SPECTRUM ROUTINE"
3204 INPUT "CUTOFF FREQUENCY"; FCO4
3206 FCO4 = FCO4 * TO0
3208 FOR I = FCO4 TO Q / 2
3210 C(I) = 0: S(I) = 0
3212 C(Q - I) = 0: S(Q - I) = 0
3214 NEXT I
3216 RETURN

